// Code generated by ent, DO NOT EDIT.

package domain

import (
	"time"

	"code.icod.de/postfix/manager/ent/predicate"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int64) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldID, id))
}

// Created applies equality check predicate on the "created" field. It's identical to CreatedEQ.
func Created(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldCreated, v))
}

// Modified applies equality check predicate on the "modified" field. It's identical to ModifiedEQ.
func Modified(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldModified, v))
}

// Domain applies equality check predicate on the "domain" field. It's identical to DomainEQ.
func Domain(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldDomain, v))
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldDescription, v))
}

// MaxAliases applies equality check predicate on the "max_aliases" field. It's identical to MaxAliasesEQ.
func MaxAliases(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxAliases, v))
}

// MaxMailboxes applies equality check predicate on the "max_mailboxes" field. It's identical to MaxMailboxesEQ.
func MaxMailboxes(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxMailboxes, v))
}

// MaxQuota applies equality check predicate on the "max_quota" field. It's identical to MaxQuotaEQ.
func MaxQuota(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxQuota, v))
}

// Quota applies equality check predicate on the "quota" field. It's identical to QuotaEQ.
func Quota(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldQuota, v))
}

// Transport applies equality check predicate on the "transport" field. It's identical to TransportEQ.
func Transport(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldTransport, v))
}

// BackupMx applies equality check predicate on the "backup_mx" field. It's identical to BackupMxEQ.
func BackupMx(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldBackupMx, v))
}

// Active applies equality check predicate on the "active" field. It's identical to ActiveEQ.
func Active(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldActive, v))
}

// CreatedEQ applies the EQ predicate on the "created" field.
func CreatedEQ(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldCreated, v))
}

// CreatedNEQ applies the NEQ predicate on the "created" field.
func CreatedNEQ(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldCreated, v))
}

// CreatedIn applies the In predicate on the "created" field.
func CreatedIn(vs ...time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldCreated, vs...))
}

// CreatedNotIn applies the NotIn predicate on the "created" field.
func CreatedNotIn(vs ...time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldCreated, vs...))
}

// CreatedGT applies the GT predicate on the "created" field.
func CreatedGT(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldCreated, v))
}

// CreatedGTE applies the GTE predicate on the "created" field.
func CreatedGTE(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldCreated, v))
}

// CreatedLT applies the LT predicate on the "created" field.
func CreatedLT(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldCreated, v))
}

// CreatedLTE applies the LTE predicate on the "created" field.
func CreatedLTE(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldCreated, v))
}

// ModifiedEQ applies the EQ predicate on the "modified" field.
func ModifiedEQ(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldModified, v))
}

// ModifiedNEQ applies the NEQ predicate on the "modified" field.
func ModifiedNEQ(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldModified, v))
}

// ModifiedIn applies the In predicate on the "modified" field.
func ModifiedIn(vs ...time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldModified, vs...))
}

// ModifiedNotIn applies the NotIn predicate on the "modified" field.
func ModifiedNotIn(vs ...time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldModified, vs...))
}

// ModifiedGT applies the GT predicate on the "modified" field.
func ModifiedGT(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldModified, v))
}

// ModifiedGTE applies the GTE predicate on the "modified" field.
func ModifiedGTE(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldModified, v))
}

// ModifiedLT applies the LT predicate on the "modified" field.
func ModifiedLT(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldModified, v))
}

// ModifiedLTE applies the LTE predicate on the "modified" field.
func ModifiedLTE(v time.Time) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldModified, v))
}

// ModifiedIsNil applies the IsNil predicate on the "modified" field.
func ModifiedIsNil() predicate.Domain {
	return predicate.Domain(sql.FieldIsNull(FieldModified))
}

// ModifiedNotNil applies the NotNil predicate on the "modified" field.
func ModifiedNotNil() predicate.Domain {
	return predicate.Domain(sql.FieldNotNull(FieldModified))
}

// DomainEQ applies the EQ predicate on the "domain" field.
func DomainEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldDomain, v))
}

// DomainNEQ applies the NEQ predicate on the "domain" field.
func DomainNEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldDomain, v))
}

// DomainIn applies the In predicate on the "domain" field.
func DomainIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldDomain, vs...))
}

// DomainNotIn applies the NotIn predicate on the "domain" field.
func DomainNotIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldDomain, vs...))
}

// DomainGT applies the GT predicate on the "domain" field.
func DomainGT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldDomain, v))
}

// DomainGTE applies the GTE predicate on the "domain" field.
func DomainGTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldDomain, v))
}

// DomainLT applies the LT predicate on the "domain" field.
func DomainLT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldDomain, v))
}

// DomainLTE applies the LTE predicate on the "domain" field.
func DomainLTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldDomain, v))
}

// DomainContains applies the Contains predicate on the "domain" field.
func DomainContains(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContains(FieldDomain, v))
}

// DomainHasPrefix applies the HasPrefix predicate on the "domain" field.
func DomainHasPrefix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasPrefix(FieldDomain, v))
}

// DomainHasSuffix applies the HasSuffix predicate on the "domain" field.
func DomainHasSuffix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasSuffix(FieldDomain, v))
}

// DomainEqualFold applies the EqualFold predicate on the "domain" field.
func DomainEqualFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEqualFold(FieldDomain, v))
}

// DomainContainsFold applies the ContainsFold predicate on the "domain" field.
func DomainContainsFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContainsFold(FieldDomain, v))
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldDescription, v))
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldDescription, v))
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldDescription, vs...))
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldDescription, vs...))
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldDescription, v))
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldDescription, v))
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldDescription, v))
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldDescription, v))
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContains(FieldDescription, v))
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasPrefix(FieldDescription, v))
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasSuffix(FieldDescription, v))
}

// DescriptionIsNil applies the IsNil predicate on the "description" field.
func DescriptionIsNil() predicate.Domain {
	return predicate.Domain(sql.FieldIsNull(FieldDescription))
}

// DescriptionNotNil applies the NotNil predicate on the "description" field.
func DescriptionNotNil() predicate.Domain {
	return predicate.Domain(sql.FieldNotNull(FieldDescription))
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEqualFold(FieldDescription, v))
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContainsFold(FieldDescription, v))
}

// MaxAliasesEQ applies the EQ predicate on the "max_aliases" field.
func MaxAliasesEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxAliases, v))
}

// MaxAliasesNEQ applies the NEQ predicate on the "max_aliases" field.
func MaxAliasesNEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldMaxAliases, v))
}

// MaxAliasesIn applies the In predicate on the "max_aliases" field.
func MaxAliasesIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldMaxAliases, vs...))
}

// MaxAliasesNotIn applies the NotIn predicate on the "max_aliases" field.
func MaxAliasesNotIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldMaxAliases, vs...))
}

// MaxAliasesGT applies the GT predicate on the "max_aliases" field.
func MaxAliasesGT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldMaxAliases, v))
}

// MaxAliasesGTE applies the GTE predicate on the "max_aliases" field.
func MaxAliasesGTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldMaxAliases, v))
}

// MaxAliasesLT applies the LT predicate on the "max_aliases" field.
func MaxAliasesLT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldMaxAliases, v))
}

// MaxAliasesLTE applies the LTE predicate on the "max_aliases" field.
func MaxAliasesLTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldMaxAliases, v))
}

// MaxMailboxesEQ applies the EQ predicate on the "max_mailboxes" field.
func MaxMailboxesEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxMailboxes, v))
}

// MaxMailboxesNEQ applies the NEQ predicate on the "max_mailboxes" field.
func MaxMailboxesNEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldMaxMailboxes, v))
}

// MaxMailboxesIn applies the In predicate on the "max_mailboxes" field.
func MaxMailboxesIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldMaxMailboxes, vs...))
}

// MaxMailboxesNotIn applies the NotIn predicate on the "max_mailboxes" field.
func MaxMailboxesNotIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldMaxMailboxes, vs...))
}

// MaxMailboxesGT applies the GT predicate on the "max_mailboxes" field.
func MaxMailboxesGT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldMaxMailboxes, v))
}

// MaxMailboxesGTE applies the GTE predicate on the "max_mailboxes" field.
func MaxMailboxesGTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldMaxMailboxes, v))
}

// MaxMailboxesLT applies the LT predicate on the "max_mailboxes" field.
func MaxMailboxesLT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldMaxMailboxes, v))
}

// MaxMailboxesLTE applies the LTE predicate on the "max_mailboxes" field.
func MaxMailboxesLTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldMaxMailboxes, v))
}

// MaxQuotaEQ applies the EQ predicate on the "max_quota" field.
func MaxQuotaEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldMaxQuota, v))
}

// MaxQuotaNEQ applies the NEQ predicate on the "max_quota" field.
func MaxQuotaNEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldMaxQuota, v))
}

// MaxQuotaIn applies the In predicate on the "max_quota" field.
func MaxQuotaIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldMaxQuota, vs...))
}

// MaxQuotaNotIn applies the NotIn predicate on the "max_quota" field.
func MaxQuotaNotIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldMaxQuota, vs...))
}

// MaxQuotaGT applies the GT predicate on the "max_quota" field.
func MaxQuotaGT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldMaxQuota, v))
}

// MaxQuotaGTE applies the GTE predicate on the "max_quota" field.
func MaxQuotaGTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldMaxQuota, v))
}

// MaxQuotaLT applies the LT predicate on the "max_quota" field.
func MaxQuotaLT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldMaxQuota, v))
}

// MaxQuotaLTE applies the LTE predicate on the "max_quota" field.
func MaxQuotaLTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldMaxQuota, v))
}

// QuotaEQ applies the EQ predicate on the "quota" field.
func QuotaEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldQuota, v))
}

// QuotaNEQ applies the NEQ predicate on the "quota" field.
func QuotaNEQ(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldQuota, v))
}

// QuotaIn applies the In predicate on the "quota" field.
func QuotaIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldQuota, vs...))
}

// QuotaNotIn applies the NotIn predicate on the "quota" field.
func QuotaNotIn(vs ...int64) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldQuota, vs...))
}

// QuotaGT applies the GT predicate on the "quota" field.
func QuotaGT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldQuota, v))
}

// QuotaGTE applies the GTE predicate on the "quota" field.
func QuotaGTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldQuota, v))
}

// QuotaLT applies the LT predicate on the "quota" field.
func QuotaLT(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldQuota, v))
}

// QuotaLTE applies the LTE predicate on the "quota" field.
func QuotaLTE(v int64) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldQuota, v))
}

// TransportEQ applies the EQ predicate on the "transport" field.
func TransportEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldTransport, v))
}

// TransportNEQ applies the NEQ predicate on the "transport" field.
func TransportNEQ(v string) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldTransport, v))
}

// TransportIn applies the In predicate on the "transport" field.
func TransportIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldIn(FieldTransport, vs...))
}

// TransportNotIn applies the NotIn predicate on the "transport" field.
func TransportNotIn(vs ...string) predicate.Domain {
	return predicate.Domain(sql.FieldNotIn(FieldTransport, vs...))
}

// TransportGT applies the GT predicate on the "transport" field.
func TransportGT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGT(FieldTransport, v))
}

// TransportGTE applies the GTE predicate on the "transport" field.
func TransportGTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldGTE(FieldTransport, v))
}

// TransportLT applies the LT predicate on the "transport" field.
func TransportLT(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLT(FieldTransport, v))
}

// TransportLTE applies the LTE predicate on the "transport" field.
func TransportLTE(v string) predicate.Domain {
	return predicate.Domain(sql.FieldLTE(FieldTransport, v))
}

// TransportContains applies the Contains predicate on the "transport" field.
func TransportContains(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContains(FieldTransport, v))
}

// TransportHasPrefix applies the HasPrefix predicate on the "transport" field.
func TransportHasPrefix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasPrefix(FieldTransport, v))
}

// TransportHasSuffix applies the HasSuffix predicate on the "transport" field.
func TransportHasSuffix(v string) predicate.Domain {
	return predicate.Domain(sql.FieldHasSuffix(FieldTransport, v))
}

// TransportEqualFold applies the EqualFold predicate on the "transport" field.
func TransportEqualFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldEqualFold(FieldTransport, v))
}

// TransportContainsFold applies the ContainsFold predicate on the "transport" field.
func TransportContainsFold(v string) predicate.Domain {
	return predicate.Domain(sql.FieldContainsFold(FieldTransport, v))
}

// BackupMxEQ applies the EQ predicate on the "backup_mx" field.
func BackupMxEQ(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldBackupMx, v))
}

// BackupMxNEQ applies the NEQ predicate on the "backup_mx" field.
func BackupMxNEQ(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldBackupMx, v))
}

// ActiveEQ applies the EQ predicate on the "active" field.
func ActiveEQ(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldEQ(FieldActive, v))
}

// ActiveNEQ applies the NEQ predicate on the "active" field.
func ActiveNEQ(v bool) predicate.Domain {
	return predicate.Domain(sql.FieldNEQ(FieldActive, v))
}

// HasMailboxes applies the HasEdge predicate on the "mailboxes" edge.
func HasMailboxes() predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, MailboxesTable, MailboxesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasMailboxesWith applies the HasEdge predicate on the "mailboxes" edge with a given conditions (other predicates).
func HasMailboxesWith(preds ...predicate.Mailbox) predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := newMailboxesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasAliases applies the HasEdge predicate on the "aliases" edge.
func HasAliases() predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, AliasesTable, AliasesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAliasesWith applies the HasEdge predicate on the "aliases" edge with a given conditions (other predicates).
func HasAliasesWith(preds ...predicate.Alias) predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := newAliasesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasLogs applies the HasEdge predicate on the "logs" edge.
func HasLogs() predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, LogsTable, LogsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasLogsWith applies the HasEdge predicate on the "logs" edge with a given conditions (other predicates).
func HasLogsWith(preds ...predicate.Logentry) predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := newLogsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasAccounts applies the HasEdge predicate on the "accounts" edge.
func HasAccounts() predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, AccountsTable, AccountsPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAccountsWith applies the HasEdge predicate on the "accounts" edge with a given conditions (other predicates).
func HasAccountsWith(preds ...predicate.Account) predicate.Domain {
	return predicate.Domain(func(s *sql.Selector) {
		step := newAccountsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Domain) predicate.Domain {
	return predicate.Domain(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Domain) predicate.Domain {
	return predicate.Domain(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Domain) predicate.Domain {
	return predicate.Domain(sql.NotPredicates(p))
}
