// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"code.icod.de/postfix/manager/ent/account"
	"code.icod.de/postfix/manager/ent/domain"
	"code.icod.de/postfix/manager/ent/logentry"
	"code.icod.de/postfix/manager/ent/predicate"
	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// LogentryQuery is the builder for querying Logentry entities.
type LogentryQuery struct {
	config
	ctx         *QueryContext
	order       []logentry.OrderOption
	inters      []Interceptor
	predicates  []predicate.Logentry
	withAccount *AccountQuery
	withDomain  *DomainQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the LogentryQuery builder.
func (lq *LogentryQuery) Where(ps ...predicate.Logentry) *LogentryQuery {
	lq.predicates = append(lq.predicates, ps...)
	return lq
}

// Limit the number of records to be returned by this query.
func (lq *LogentryQuery) Limit(limit int) *LogentryQuery {
	lq.ctx.Limit = &limit
	return lq
}

// Offset to start from.
func (lq *LogentryQuery) Offset(offset int) *LogentryQuery {
	lq.ctx.Offset = &offset
	return lq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (lq *LogentryQuery) Unique(unique bool) *LogentryQuery {
	lq.ctx.Unique = &unique
	return lq
}

// Order specifies how the records should be ordered.
func (lq *LogentryQuery) Order(o ...logentry.OrderOption) *LogentryQuery {
	lq.order = append(lq.order, o...)
	return lq
}

// QueryAccount chains the current query on the "account" edge.
func (lq *LogentryQuery) QueryAccount() *AccountQuery {
	query := (&AccountClient{config: lq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := lq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := lq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(logentry.Table, logentry.FieldID, selector),
			sqlgraph.To(account.Table, account.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, logentry.AccountTable, logentry.AccountColumn),
		)
		fromU = sqlgraph.SetNeighbors(lq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryDomain chains the current query on the "domain" edge.
func (lq *LogentryQuery) QueryDomain() *DomainQuery {
	query := (&DomainClient{config: lq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := lq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := lq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(logentry.Table, logentry.FieldID, selector),
			sqlgraph.To(domain.Table, domain.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, logentry.DomainTable, logentry.DomainColumn),
		)
		fromU = sqlgraph.SetNeighbors(lq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Logentry entity from the query.
// Returns a *NotFoundError when no Logentry was found.
func (lq *LogentryQuery) First(ctx context.Context) (*Logentry, error) {
	nodes, err := lq.Limit(1).All(setContextOp(ctx, lq.ctx, ent.OpQueryFirst))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{logentry.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (lq *LogentryQuery) FirstX(ctx context.Context) *Logentry {
	node, err := lq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Logentry ID from the query.
// Returns a *NotFoundError when no Logentry ID was found.
func (lq *LogentryQuery) FirstID(ctx context.Context) (id int64, err error) {
	var ids []int64
	if ids, err = lq.Limit(1).IDs(setContextOp(ctx, lq.ctx, ent.OpQueryFirstID)); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{logentry.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (lq *LogentryQuery) FirstIDX(ctx context.Context) int64 {
	id, err := lq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Logentry entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Logentry entity is found.
// Returns a *NotFoundError when no Logentry entities are found.
func (lq *LogentryQuery) Only(ctx context.Context) (*Logentry, error) {
	nodes, err := lq.Limit(2).All(setContextOp(ctx, lq.ctx, ent.OpQueryOnly))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{logentry.Label}
	default:
		return nil, &NotSingularError{logentry.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (lq *LogentryQuery) OnlyX(ctx context.Context) *Logentry {
	node, err := lq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Logentry ID in the query.
// Returns a *NotSingularError when more than one Logentry ID is found.
// Returns a *NotFoundError when no entities are found.
func (lq *LogentryQuery) OnlyID(ctx context.Context) (id int64, err error) {
	var ids []int64
	if ids, err = lq.Limit(2).IDs(setContextOp(ctx, lq.ctx, ent.OpQueryOnlyID)); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{logentry.Label}
	default:
		err = &NotSingularError{logentry.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (lq *LogentryQuery) OnlyIDX(ctx context.Context) int64 {
	id, err := lq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Logentries.
func (lq *LogentryQuery) All(ctx context.Context) ([]*Logentry, error) {
	ctx = setContextOp(ctx, lq.ctx, ent.OpQueryAll)
	if err := lq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Logentry, *LogentryQuery]()
	return withInterceptors[[]*Logentry](ctx, lq, qr, lq.inters)
}

// AllX is like All, but panics if an error occurs.
func (lq *LogentryQuery) AllX(ctx context.Context) []*Logentry {
	nodes, err := lq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Logentry IDs.
func (lq *LogentryQuery) IDs(ctx context.Context) (ids []int64, err error) {
	if lq.ctx.Unique == nil && lq.path != nil {
		lq.Unique(true)
	}
	ctx = setContextOp(ctx, lq.ctx, ent.OpQueryIDs)
	if err = lq.Select(logentry.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (lq *LogentryQuery) IDsX(ctx context.Context) []int64 {
	ids, err := lq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (lq *LogentryQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, lq.ctx, ent.OpQueryCount)
	if err := lq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, lq, querierCount[*LogentryQuery](), lq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (lq *LogentryQuery) CountX(ctx context.Context) int {
	count, err := lq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (lq *LogentryQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, lq.ctx, ent.OpQueryExist)
	switch _, err := lq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (lq *LogentryQuery) ExistX(ctx context.Context) bool {
	exist, err := lq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the LogentryQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (lq *LogentryQuery) Clone() *LogentryQuery {
	if lq == nil {
		return nil
	}
	return &LogentryQuery{
		config:      lq.config,
		ctx:         lq.ctx.Clone(),
		order:       append([]logentry.OrderOption{}, lq.order...),
		inters:      append([]Interceptor{}, lq.inters...),
		predicates:  append([]predicate.Logentry{}, lq.predicates...),
		withAccount: lq.withAccount.Clone(),
		withDomain:  lq.withDomain.Clone(),
		// clone intermediate query.
		sql:  lq.sql.Clone(),
		path: lq.path,
	}
}

// WithAccount tells the query-builder to eager-load the nodes that are connected to
// the "account" edge. The optional arguments are used to configure the query builder of the edge.
func (lq *LogentryQuery) WithAccount(opts ...func(*AccountQuery)) *LogentryQuery {
	query := (&AccountClient{config: lq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	lq.withAccount = query
	return lq
}

// WithDomain tells the query-builder to eager-load the nodes that are connected to
// the "domain" edge. The optional arguments are used to configure the query builder of the edge.
func (lq *LogentryQuery) WithDomain(opts ...func(*DomainQuery)) *LogentryQuery {
	query := (&DomainClient{config: lq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	lq.withDomain = query
	return lq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Timestamp time.Time `json:"timestamp,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Logentry.Query().
//		GroupBy(logentry.FieldTimestamp).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (lq *LogentryQuery) GroupBy(field string, fields ...string) *LogentryGroupBy {
	lq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &LogentryGroupBy{build: lq}
	grbuild.flds = &lq.ctx.Fields
	grbuild.label = logentry.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Timestamp time.Time `json:"timestamp,omitempty"`
//	}
//
//	client.Logentry.Query().
//		Select(logentry.FieldTimestamp).
//		Scan(ctx, &v)
func (lq *LogentryQuery) Select(fields ...string) *LogentrySelect {
	lq.ctx.Fields = append(lq.ctx.Fields, fields...)
	sbuild := &LogentrySelect{LogentryQuery: lq}
	sbuild.label = logentry.Label
	sbuild.flds, sbuild.scan = &lq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a LogentrySelect configured with the given aggregations.
func (lq *LogentryQuery) Aggregate(fns ...AggregateFunc) *LogentrySelect {
	return lq.Select().Aggregate(fns...)
}

func (lq *LogentryQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range lq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, lq); err != nil {
				return err
			}
		}
	}
	for _, f := range lq.ctx.Fields {
		if !logentry.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if lq.path != nil {
		prev, err := lq.path(ctx)
		if err != nil {
			return err
		}
		lq.sql = prev
	}
	return nil
}

func (lq *LogentryQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Logentry, error) {
	var (
		nodes       = []*Logentry{}
		_spec       = lq.querySpec()
		loadedTypes = [2]bool{
			lq.withAccount != nil,
			lq.withDomain != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Logentry).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Logentry{config: lq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, lq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := lq.withAccount; query != nil {
		if err := lq.loadAccount(ctx, query, nodes, nil,
			func(n *Logentry, e *Account) { n.Edges.Account = e }); err != nil {
			return nil, err
		}
	}
	if query := lq.withDomain; query != nil {
		if err := lq.loadDomain(ctx, query, nodes, nil,
			func(n *Logentry, e *Domain) { n.Edges.Domain = e }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (lq *LogentryQuery) loadAccount(ctx context.Context, query *AccountQuery, nodes []*Logentry, init func(*Logentry), assign func(*Logentry, *Account)) error {
	ids := make([]int64, 0, len(nodes))
	nodeids := make(map[int64][]*Logentry)
	for i := range nodes {
		fk := nodes[i].AccountID
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(account.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "account_id" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}
func (lq *LogentryQuery) loadDomain(ctx context.Context, query *DomainQuery, nodes []*Logentry, init func(*Logentry), assign func(*Logentry, *Domain)) error {
	ids := make([]int64, 0, len(nodes))
	nodeids := make(map[int64][]*Logentry)
	for i := range nodes {
		fk := nodes[i].DomainID
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(domain.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "domain_id" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}

func (lq *LogentryQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := lq.querySpec()
	_spec.Node.Columns = lq.ctx.Fields
	if len(lq.ctx.Fields) > 0 {
		_spec.Unique = lq.ctx.Unique != nil && *lq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, lq.driver, _spec)
}

func (lq *LogentryQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(logentry.Table, logentry.Columns, sqlgraph.NewFieldSpec(logentry.FieldID, field.TypeInt64))
	_spec.From = lq.sql
	if unique := lq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if lq.path != nil {
		_spec.Unique = true
	}
	if fields := lq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, logentry.FieldID)
		for i := range fields {
			if fields[i] != logentry.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
		if lq.withAccount != nil {
			_spec.Node.AddColumnOnce(logentry.FieldAccountID)
		}
		if lq.withDomain != nil {
			_spec.Node.AddColumnOnce(logentry.FieldDomainID)
		}
	}
	if ps := lq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := lq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := lq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := lq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (lq *LogentryQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(lq.driver.Dialect())
	t1 := builder.Table(logentry.Table)
	columns := lq.ctx.Fields
	if len(columns) == 0 {
		columns = logentry.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if lq.sql != nil {
		selector = lq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if lq.ctx.Unique != nil && *lq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range lq.predicates {
		p(selector)
	}
	for _, p := range lq.order {
		p(selector)
	}
	if offset := lq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := lq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// LogentryGroupBy is the group-by builder for Logentry entities.
type LogentryGroupBy struct {
	selector
	build *LogentryQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (lgb *LogentryGroupBy) Aggregate(fns ...AggregateFunc) *LogentryGroupBy {
	lgb.fns = append(lgb.fns, fns...)
	return lgb
}

// Scan applies the selector query and scans the result into the given value.
func (lgb *LogentryGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, lgb.build.ctx, ent.OpQueryGroupBy)
	if err := lgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*LogentryQuery, *LogentryGroupBy](ctx, lgb.build, lgb, lgb.build.inters, v)
}

func (lgb *LogentryGroupBy) sqlScan(ctx context.Context, root *LogentryQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(lgb.fns))
	for _, fn := range lgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*lgb.flds)+len(lgb.fns))
		for _, f := range *lgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*lgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := lgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// LogentrySelect is the builder for selecting fields of Logentry entities.
type LogentrySelect struct {
	*LogentryQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ls *LogentrySelect) Aggregate(fns ...AggregateFunc) *LogentrySelect {
	ls.fns = append(ls.fns, fns...)
	return ls
}

// Scan applies the selector query and scans the result into the given value.
func (ls *LogentrySelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ls.ctx, ent.OpQuerySelect)
	if err := ls.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*LogentryQuery, *LogentrySelect](ctx, ls.LogentryQuery, ls, ls.inters, v)
}

func (ls *LogentrySelect) sqlScan(ctx context.Context, root *LogentryQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ls.fns))
	for _, fn := range ls.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ls.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ls.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
