// Code generated by ent, DO NOT EDIT.

package mailbox

import (
	"time"

	"code.icod.de/postfix/manager/ent/predicate"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldID, id))
}

// Active applies equality check predicate on the "active" field. It's identical to ActiveEQ.
func Active(v bool) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldActive, v))
}

// Created applies equality check predicate on the "created" field. It's identical to CreatedEQ.
func Created(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldCreated, v))
}

// Modified applies equality check predicate on the "modified" field. It's identical to ModifiedEQ.
func Modified(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldModified, v))
}

// DomainID applies equality check predicate on the "domain_id" field. It's identical to DomainIDEQ.
func DomainID(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldDomainID, v))
}

// Username applies equality check predicate on the "username" field. It's identical to UsernameEQ.
func Username(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldUsername, v))
}

// Password applies equality check predicate on the "password" field. It's identical to PasswordEQ.
func Password(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldPassword, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldName, v))
}

// Quota applies equality check predicate on the "quota" field. It's identical to QuotaEQ.
func Quota(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldQuota, v))
}

// LocalPart applies equality check predicate on the "local_part" field. It's identical to LocalPartEQ.
func LocalPart(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldLocalPart, v))
}

// Homedir applies equality check predicate on the "homedir" field. It's identical to HomedirEQ.
func Homedir(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldHomedir, v))
}

// Maildir applies equality check predicate on the "maildir" field. It's identical to MaildirEQ.
func Maildir(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldMaildir, v))
}

// UID applies equality check predicate on the "uid" field. It's identical to UIDEQ.
func UID(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldUID, v))
}

// Gid applies equality check predicate on the "gid" field. It's identical to GidEQ.
func Gid(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldGid, v))
}

// ActiveEQ applies the EQ predicate on the "active" field.
func ActiveEQ(v bool) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldActive, v))
}

// ActiveNEQ applies the NEQ predicate on the "active" field.
func ActiveNEQ(v bool) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldActive, v))
}

// CreatedEQ applies the EQ predicate on the "created" field.
func CreatedEQ(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldCreated, v))
}

// CreatedNEQ applies the NEQ predicate on the "created" field.
func CreatedNEQ(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldCreated, v))
}

// CreatedIn applies the In predicate on the "created" field.
func CreatedIn(vs ...time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldCreated, vs...))
}

// CreatedNotIn applies the NotIn predicate on the "created" field.
func CreatedNotIn(vs ...time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldCreated, vs...))
}

// CreatedGT applies the GT predicate on the "created" field.
func CreatedGT(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldCreated, v))
}

// CreatedGTE applies the GTE predicate on the "created" field.
func CreatedGTE(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldCreated, v))
}

// CreatedLT applies the LT predicate on the "created" field.
func CreatedLT(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldCreated, v))
}

// CreatedLTE applies the LTE predicate on the "created" field.
func CreatedLTE(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldCreated, v))
}

// ModifiedEQ applies the EQ predicate on the "modified" field.
func ModifiedEQ(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldModified, v))
}

// ModifiedNEQ applies the NEQ predicate on the "modified" field.
func ModifiedNEQ(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldModified, v))
}

// ModifiedIn applies the In predicate on the "modified" field.
func ModifiedIn(vs ...time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldModified, vs...))
}

// ModifiedNotIn applies the NotIn predicate on the "modified" field.
func ModifiedNotIn(vs ...time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldModified, vs...))
}

// ModifiedGT applies the GT predicate on the "modified" field.
func ModifiedGT(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldModified, v))
}

// ModifiedGTE applies the GTE predicate on the "modified" field.
func ModifiedGTE(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldModified, v))
}

// ModifiedLT applies the LT predicate on the "modified" field.
func ModifiedLT(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldModified, v))
}

// ModifiedLTE applies the LTE predicate on the "modified" field.
func ModifiedLTE(v time.Time) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldModified, v))
}

// ModifiedIsNil applies the IsNil predicate on the "modified" field.
func ModifiedIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldModified))
}

// ModifiedNotNil applies the NotNil predicate on the "modified" field.
func ModifiedNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldModified))
}

// DomainIDEQ applies the EQ predicate on the "domain_id" field.
func DomainIDEQ(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldDomainID, v))
}

// DomainIDNEQ applies the NEQ predicate on the "domain_id" field.
func DomainIDNEQ(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldDomainID, v))
}

// DomainIDIn applies the In predicate on the "domain_id" field.
func DomainIDIn(vs ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldDomainID, vs...))
}

// DomainIDNotIn applies the NotIn predicate on the "domain_id" field.
func DomainIDNotIn(vs ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldDomainID, vs...))
}

// DomainIDIsNil applies the IsNil predicate on the "domain_id" field.
func DomainIDIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldDomainID))
}

// DomainIDNotNil applies the NotNil predicate on the "domain_id" field.
func DomainIDNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldDomainID))
}

// UsernameEQ applies the EQ predicate on the "username" field.
func UsernameEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldUsername, v))
}

// UsernameNEQ applies the NEQ predicate on the "username" field.
func UsernameNEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldUsername, v))
}

// UsernameIn applies the In predicate on the "username" field.
func UsernameIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldUsername, vs...))
}

// UsernameNotIn applies the NotIn predicate on the "username" field.
func UsernameNotIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldUsername, vs...))
}

// UsernameGT applies the GT predicate on the "username" field.
func UsernameGT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldUsername, v))
}

// UsernameGTE applies the GTE predicate on the "username" field.
func UsernameGTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldUsername, v))
}

// UsernameLT applies the LT predicate on the "username" field.
func UsernameLT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldUsername, v))
}

// UsernameLTE applies the LTE predicate on the "username" field.
func UsernameLTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldUsername, v))
}

// UsernameContains applies the Contains predicate on the "username" field.
func UsernameContains(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContains(FieldUsername, v))
}

// UsernameHasPrefix applies the HasPrefix predicate on the "username" field.
func UsernameHasPrefix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasPrefix(FieldUsername, v))
}

// UsernameHasSuffix applies the HasSuffix predicate on the "username" field.
func UsernameHasSuffix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasSuffix(FieldUsername, v))
}

// UsernameEqualFold applies the EqualFold predicate on the "username" field.
func UsernameEqualFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEqualFold(FieldUsername, v))
}

// UsernameContainsFold applies the ContainsFold predicate on the "username" field.
func UsernameContainsFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContainsFold(FieldUsername, v))
}

// PasswordEQ applies the EQ predicate on the "password" field.
func PasswordEQ(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldPassword, v))
}

// PasswordNEQ applies the NEQ predicate on the "password" field.
func PasswordNEQ(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldPassword, v))
}

// PasswordIn applies the In predicate on the "password" field.
func PasswordIn(vs ...[]byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldPassword, vs...))
}

// PasswordNotIn applies the NotIn predicate on the "password" field.
func PasswordNotIn(vs ...[]byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldPassword, vs...))
}

// PasswordGT applies the GT predicate on the "password" field.
func PasswordGT(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldPassword, v))
}

// PasswordGTE applies the GTE predicate on the "password" field.
func PasswordGTE(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldPassword, v))
}

// PasswordLT applies the LT predicate on the "password" field.
func PasswordLT(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldPassword, v))
}

// PasswordLTE applies the LTE predicate on the "password" field.
func PasswordLTE(v []byte) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldPassword, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasSuffix(FieldName, v))
}

// NameIsNil applies the IsNil predicate on the "name" field.
func NameIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldName))
}

// NameNotNil applies the NotNil predicate on the "name" field.
func NameNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldName))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContainsFold(FieldName, v))
}

// QuotaEQ applies the EQ predicate on the "quota" field.
func QuotaEQ(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldQuota, v))
}

// QuotaNEQ applies the NEQ predicate on the "quota" field.
func QuotaNEQ(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldQuota, v))
}

// QuotaIn applies the In predicate on the "quota" field.
func QuotaIn(vs ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldQuota, vs...))
}

// QuotaNotIn applies the NotIn predicate on the "quota" field.
func QuotaNotIn(vs ...int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldQuota, vs...))
}

// QuotaGT applies the GT predicate on the "quota" field.
func QuotaGT(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldQuota, v))
}

// QuotaGTE applies the GTE predicate on the "quota" field.
func QuotaGTE(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldQuota, v))
}

// QuotaLT applies the LT predicate on the "quota" field.
func QuotaLT(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldQuota, v))
}

// QuotaLTE applies the LTE predicate on the "quota" field.
func QuotaLTE(v int64) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldQuota, v))
}

// LocalPartEQ applies the EQ predicate on the "local_part" field.
func LocalPartEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldLocalPart, v))
}

// LocalPartNEQ applies the NEQ predicate on the "local_part" field.
func LocalPartNEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldLocalPart, v))
}

// LocalPartIn applies the In predicate on the "local_part" field.
func LocalPartIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldLocalPart, vs...))
}

// LocalPartNotIn applies the NotIn predicate on the "local_part" field.
func LocalPartNotIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldLocalPart, vs...))
}

// LocalPartGT applies the GT predicate on the "local_part" field.
func LocalPartGT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldLocalPart, v))
}

// LocalPartGTE applies the GTE predicate on the "local_part" field.
func LocalPartGTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldLocalPart, v))
}

// LocalPartLT applies the LT predicate on the "local_part" field.
func LocalPartLT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldLocalPart, v))
}

// LocalPartLTE applies the LTE predicate on the "local_part" field.
func LocalPartLTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldLocalPart, v))
}

// LocalPartContains applies the Contains predicate on the "local_part" field.
func LocalPartContains(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContains(FieldLocalPart, v))
}

// LocalPartHasPrefix applies the HasPrefix predicate on the "local_part" field.
func LocalPartHasPrefix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasPrefix(FieldLocalPart, v))
}

// LocalPartHasSuffix applies the HasSuffix predicate on the "local_part" field.
func LocalPartHasSuffix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasSuffix(FieldLocalPart, v))
}

// LocalPartEqualFold applies the EqualFold predicate on the "local_part" field.
func LocalPartEqualFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEqualFold(FieldLocalPart, v))
}

// LocalPartContainsFold applies the ContainsFold predicate on the "local_part" field.
func LocalPartContainsFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContainsFold(FieldLocalPart, v))
}

// HomedirEQ applies the EQ predicate on the "homedir" field.
func HomedirEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldHomedir, v))
}

// HomedirNEQ applies the NEQ predicate on the "homedir" field.
func HomedirNEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldHomedir, v))
}

// HomedirIn applies the In predicate on the "homedir" field.
func HomedirIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldHomedir, vs...))
}

// HomedirNotIn applies the NotIn predicate on the "homedir" field.
func HomedirNotIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldHomedir, vs...))
}

// HomedirGT applies the GT predicate on the "homedir" field.
func HomedirGT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldHomedir, v))
}

// HomedirGTE applies the GTE predicate on the "homedir" field.
func HomedirGTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldHomedir, v))
}

// HomedirLT applies the LT predicate on the "homedir" field.
func HomedirLT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldHomedir, v))
}

// HomedirLTE applies the LTE predicate on the "homedir" field.
func HomedirLTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldHomedir, v))
}

// HomedirContains applies the Contains predicate on the "homedir" field.
func HomedirContains(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContains(FieldHomedir, v))
}

// HomedirHasPrefix applies the HasPrefix predicate on the "homedir" field.
func HomedirHasPrefix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasPrefix(FieldHomedir, v))
}

// HomedirHasSuffix applies the HasSuffix predicate on the "homedir" field.
func HomedirHasSuffix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasSuffix(FieldHomedir, v))
}

// HomedirIsNil applies the IsNil predicate on the "homedir" field.
func HomedirIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldHomedir))
}

// HomedirNotNil applies the NotNil predicate on the "homedir" field.
func HomedirNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldHomedir))
}

// HomedirEqualFold applies the EqualFold predicate on the "homedir" field.
func HomedirEqualFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEqualFold(FieldHomedir, v))
}

// HomedirContainsFold applies the ContainsFold predicate on the "homedir" field.
func HomedirContainsFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContainsFold(FieldHomedir, v))
}

// MaildirEQ applies the EQ predicate on the "maildir" field.
func MaildirEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldMaildir, v))
}

// MaildirNEQ applies the NEQ predicate on the "maildir" field.
func MaildirNEQ(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldMaildir, v))
}

// MaildirIn applies the In predicate on the "maildir" field.
func MaildirIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldMaildir, vs...))
}

// MaildirNotIn applies the NotIn predicate on the "maildir" field.
func MaildirNotIn(vs ...string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldMaildir, vs...))
}

// MaildirGT applies the GT predicate on the "maildir" field.
func MaildirGT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldMaildir, v))
}

// MaildirGTE applies the GTE predicate on the "maildir" field.
func MaildirGTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldMaildir, v))
}

// MaildirLT applies the LT predicate on the "maildir" field.
func MaildirLT(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldMaildir, v))
}

// MaildirLTE applies the LTE predicate on the "maildir" field.
func MaildirLTE(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldMaildir, v))
}

// MaildirContains applies the Contains predicate on the "maildir" field.
func MaildirContains(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContains(FieldMaildir, v))
}

// MaildirHasPrefix applies the HasPrefix predicate on the "maildir" field.
func MaildirHasPrefix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasPrefix(FieldMaildir, v))
}

// MaildirHasSuffix applies the HasSuffix predicate on the "maildir" field.
func MaildirHasSuffix(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldHasSuffix(FieldMaildir, v))
}

// MaildirIsNil applies the IsNil predicate on the "maildir" field.
func MaildirIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldMaildir))
}

// MaildirNotNil applies the NotNil predicate on the "maildir" field.
func MaildirNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldMaildir))
}

// MaildirEqualFold applies the EqualFold predicate on the "maildir" field.
func MaildirEqualFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEqualFold(FieldMaildir, v))
}

// MaildirContainsFold applies the ContainsFold predicate on the "maildir" field.
func MaildirContainsFold(v string) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldContainsFold(FieldMaildir, v))
}

// UIDEQ applies the EQ predicate on the "uid" field.
func UIDEQ(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldUID, v))
}

// UIDNEQ applies the NEQ predicate on the "uid" field.
func UIDNEQ(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldUID, v))
}

// UIDIn applies the In predicate on the "uid" field.
func UIDIn(vs ...int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldUID, vs...))
}

// UIDNotIn applies the NotIn predicate on the "uid" field.
func UIDNotIn(vs ...int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldUID, vs...))
}

// UIDGT applies the GT predicate on the "uid" field.
func UIDGT(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldUID, v))
}

// UIDGTE applies the GTE predicate on the "uid" field.
func UIDGTE(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldUID, v))
}

// UIDLT applies the LT predicate on the "uid" field.
func UIDLT(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldUID, v))
}

// UIDLTE applies the LTE predicate on the "uid" field.
func UIDLTE(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldUID, v))
}

// UIDIsNil applies the IsNil predicate on the "uid" field.
func UIDIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldUID))
}

// UIDNotNil applies the NotNil predicate on the "uid" field.
func UIDNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldUID))
}

// GidEQ applies the EQ predicate on the "gid" field.
func GidEQ(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldEQ(FieldGid, v))
}

// GidNEQ applies the NEQ predicate on the "gid" field.
func GidNEQ(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNEQ(FieldGid, v))
}

// GidIn applies the In predicate on the "gid" field.
func GidIn(vs ...int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIn(FieldGid, vs...))
}

// GidNotIn applies the NotIn predicate on the "gid" field.
func GidNotIn(vs ...int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotIn(FieldGid, vs...))
}

// GidGT applies the GT predicate on the "gid" field.
func GidGT(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGT(FieldGid, v))
}

// GidGTE applies the GTE predicate on the "gid" field.
func GidGTE(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldGTE(FieldGid, v))
}

// GidLT applies the LT predicate on the "gid" field.
func GidLT(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLT(FieldGid, v))
}

// GidLTE applies the LTE predicate on the "gid" field.
func GidLTE(v int32) predicate.Mailbox {
	return predicate.Mailbox(sql.FieldLTE(FieldGid, v))
}

// GidIsNil applies the IsNil predicate on the "gid" field.
func GidIsNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldIsNull(FieldGid))
}

// GidNotNil applies the NotNil predicate on the "gid" field.
func GidNotNil() predicate.Mailbox {
	return predicate.Mailbox(sql.FieldNotNull(FieldGid))
}

// HasDomain applies the HasEdge predicate on the "domain" edge.
func HasDomain() predicate.Mailbox {
	return predicate.Mailbox(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, DomainTable, DomainColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasDomainWith applies the HasEdge predicate on the "domain" edge with a given conditions (other predicates).
func HasDomainWith(preds ...predicate.Domain) predicate.Mailbox {
	return predicate.Mailbox(func(s *sql.Selector) {
		step := newDomainStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Mailbox) predicate.Mailbox {
	return predicate.Mailbox(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Mailbox) predicate.Mailbox {
	return predicate.Mailbox(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Mailbox) predicate.Mailbox {
	return predicate.Mailbox(sql.NotPredicates(p))
}
