// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"code.icod.de/postfix/manager/ent/domain"
	"code.icod.de/postfix/manager/ent/mailbox"
	"code.icod.de/postfix/manager/ent/predicate"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// MailboxUpdate is the builder for updating Mailbox entities.
type MailboxUpdate struct {
	config
	hooks    []Hook
	mutation *MailboxMutation
}

// Where appends a list predicates to the MailboxUpdate builder.
func (mu *MailboxUpdate) Where(ps ...predicate.Mailbox) *MailboxUpdate {
	mu.mutation.Where(ps...)
	return mu
}

// SetActive sets the "active" field.
func (mu *MailboxUpdate) SetActive(b bool) *MailboxUpdate {
	mu.mutation.SetActive(b)
	return mu
}

// SetNillableActive sets the "active" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableActive(b *bool) *MailboxUpdate {
	if b != nil {
		mu.SetActive(*b)
	}
	return mu
}

// SetModified sets the "modified" field.
func (mu *MailboxUpdate) SetModified(t time.Time) *MailboxUpdate {
	mu.mutation.SetModified(t)
	return mu
}

// ClearModified clears the value of the "modified" field.
func (mu *MailboxUpdate) ClearModified() *MailboxUpdate {
	mu.mutation.ClearModified()
	return mu
}

// SetDomainID sets the "domain_id" field.
func (mu *MailboxUpdate) SetDomainID(i int64) *MailboxUpdate {
	mu.mutation.SetDomainID(i)
	return mu
}

// SetNillableDomainID sets the "domain_id" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableDomainID(i *int64) *MailboxUpdate {
	if i != nil {
		mu.SetDomainID(*i)
	}
	return mu
}

// ClearDomainID clears the value of the "domain_id" field.
func (mu *MailboxUpdate) ClearDomainID() *MailboxUpdate {
	mu.mutation.ClearDomainID()
	return mu
}

// SetUsername sets the "username" field.
func (mu *MailboxUpdate) SetUsername(s string) *MailboxUpdate {
	mu.mutation.SetUsername(s)
	return mu
}

// SetNillableUsername sets the "username" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableUsername(s *string) *MailboxUpdate {
	if s != nil {
		mu.SetUsername(*s)
	}
	return mu
}

// SetPassword sets the "password" field.
func (mu *MailboxUpdate) SetPassword(b []byte) *MailboxUpdate {
	mu.mutation.SetPassword(b)
	return mu
}

// SetName sets the "name" field.
func (mu *MailboxUpdate) SetName(s string) *MailboxUpdate {
	mu.mutation.SetName(s)
	return mu
}

// SetNillableName sets the "name" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableName(s *string) *MailboxUpdate {
	if s != nil {
		mu.SetName(*s)
	}
	return mu
}

// ClearName clears the value of the "name" field.
func (mu *MailboxUpdate) ClearName() *MailboxUpdate {
	mu.mutation.ClearName()
	return mu
}

// SetQuota sets the "quota" field.
func (mu *MailboxUpdate) SetQuota(i int64) *MailboxUpdate {
	mu.mutation.ResetQuota()
	mu.mutation.SetQuota(i)
	return mu
}

// SetNillableQuota sets the "quota" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableQuota(i *int64) *MailboxUpdate {
	if i != nil {
		mu.SetQuota(*i)
	}
	return mu
}

// AddQuota adds i to the "quota" field.
func (mu *MailboxUpdate) AddQuota(i int64) *MailboxUpdate {
	mu.mutation.AddQuota(i)
	return mu
}

// SetLocalPart sets the "local_part" field.
func (mu *MailboxUpdate) SetLocalPart(s string) *MailboxUpdate {
	mu.mutation.SetLocalPart(s)
	return mu
}

// SetNillableLocalPart sets the "local_part" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableLocalPart(s *string) *MailboxUpdate {
	if s != nil {
		mu.SetLocalPart(*s)
	}
	return mu
}

// SetHomedir sets the "homedir" field.
func (mu *MailboxUpdate) SetHomedir(s string) *MailboxUpdate {
	mu.mutation.SetHomedir(s)
	return mu
}

// SetNillableHomedir sets the "homedir" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableHomedir(s *string) *MailboxUpdate {
	if s != nil {
		mu.SetHomedir(*s)
	}
	return mu
}

// ClearHomedir clears the value of the "homedir" field.
func (mu *MailboxUpdate) ClearHomedir() *MailboxUpdate {
	mu.mutation.ClearHomedir()
	return mu
}

// SetMaildir sets the "maildir" field.
func (mu *MailboxUpdate) SetMaildir(s string) *MailboxUpdate {
	mu.mutation.SetMaildir(s)
	return mu
}

// SetNillableMaildir sets the "maildir" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableMaildir(s *string) *MailboxUpdate {
	if s != nil {
		mu.SetMaildir(*s)
	}
	return mu
}

// ClearMaildir clears the value of the "maildir" field.
func (mu *MailboxUpdate) ClearMaildir() *MailboxUpdate {
	mu.mutation.ClearMaildir()
	return mu
}

// SetUID sets the "uid" field.
func (mu *MailboxUpdate) SetUID(i int32) *MailboxUpdate {
	mu.mutation.ResetUID()
	mu.mutation.SetUID(i)
	return mu
}

// SetNillableUID sets the "uid" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableUID(i *int32) *MailboxUpdate {
	if i != nil {
		mu.SetUID(*i)
	}
	return mu
}

// AddUID adds i to the "uid" field.
func (mu *MailboxUpdate) AddUID(i int32) *MailboxUpdate {
	mu.mutation.AddUID(i)
	return mu
}

// ClearUID clears the value of the "uid" field.
func (mu *MailboxUpdate) ClearUID() *MailboxUpdate {
	mu.mutation.ClearUID()
	return mu
}

// SetGid sets the "gid" field.
func (mu *MailboxUpdate) SetGid(i int32) *MailboxUpdate {
	mu.mutation.ResetGid()
	mu.mutation.SetGid(i)
	return mu
}

// SetNillableGid sets the "gid" field if the given value is not nil.
func (mu *MailboxUpdate) SetNillableGid(i *int32) *MailboxUpdate {
	if i != nil {
		mu.SetGid(*i)
	}
	return mu
}

// AddGid adds i to the "gid" field.
func (mu *MailboxUpdate) AddGid(i int32) *MailboxUpdate {
	mu.mutation.AddGid(i)
	return mu
}

// ClearGid clears the value of the "gid" field.
func (mu *MailboxUpdate) ClearGid() *MailboxUpdate {
	mu.mutation.ClearGid()
	return mu
}

// SetDomain sets the "domain" edge to the Domain entity.
func (mu *MailboxUpdate) SetDomain(d *Domain) *MailboxUpdate {
	return mu.SetDomainID(d.ID)
}

// Mutation returns the MailboxMutation object of the builder.
func (mu *MailboxUpdate) Mutation() *MailboxMutation {
	return mu.mutation
}

// ClearDomain clears the "domain" edge to the Domain entity.
func (mu *MailboxUpdate) ClearDomain() *MailboxUpdate {
	mu.mutation.ClearDomain()
	return mu
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (mu *MailboxUpdate) Save(ctx context.Context) (int, error) {
	mu.defaults()
	return withHooks(ctx, mu.sqlSave, mu.mutation, mu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (mu *MailboxUpdate) SaveX(ctx context.Context) int {
	affected, err := mu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (mu *MailboxUpdate) Exec(ctx context.Context) error {
	_, err := mu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (mu *MailboxUpdate) ExecX(ctx context.Context) {
	if err := mu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (mu *MailboxUpdate) defaults() {
	if _, ok := mu.mutation.Modified(); !ok && !mu.mutation.ModifiedCleared() {
		v := mailbox.UpdateDefaultModified()
		mu.mutation.SetModified(v)
	}
}

func (mu *MailboxUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := sqlgraph.NewUpdateSpec(mailbox.Table, mailbox.Columns, sqlgraph.NewFieldSpec(mailbox.FieldID, field.TypeInt64))
	if ps := mu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := mu.mutation.Active(); ok {
		_spec.SetField(mailbox.FieldActive, field.TypeBool, value)
	}
	if value, ok := mu.mutation.Modified(); ok {
		_spec.SetField(mailbox.FieldModified, field.TypeTime, value)
	}
	if mu.mutation.ModifiedCleared() {
		_spec.ClearField(mailbox.FieldModified, field.TypeTime)
	}
	if value, ok := mu.mutation.Username(); ok {
		_spec.SetField(mailbox.FieldUsername, field.TypeString, value)
	}
	if value, ok := mu.mutation.Password(); ok {
		_spec.SetField(mailbox.FieldPassword, field.TypeBytes, value)
	}
	if value, ok := mu.mutation.Name(); ok {
		_spec.SetField(mailbox.FieldName, field.TypeString, value)
	}
	if mu.mutation.NameCleared() {
		_spec.ClearField(mailbox.FieldName, field.TypeString)
	}
	if value, ok := mu.mutation.Quota(); ok {
		_spec.SetField(mailbox.FieldQuota, field.TypeInt64, value)
	}
	if value, ok := mu.mutation.AddedQuota(); ok {
		_spec.AddField(mailbox.FieldQuota, field.TypeInt64, value)
	}
	if value, ok := mu.mutation.LocalPart(); ok {
		_spec.SetField(mailbox.FieldLocalPart, field.TypeString, value)
	}
	if value, ok := mu.mutation.Homedir(); ok {
		_spec.SetField(mailbox.FieldHomedir, field.TypeString, value)
	}
	if mu.mutation.HomedirCleared() {
		_spec.ClearField(mailbox.FieldHomedir, field.TypeString)
	}
	if value, ok := mu.mutation.Maildir(); ok {
		_spec.SetField(mailbox.FieldMaildir, field.TypeString, value)
	}
	if mu.mutation.MaildirCleared() {
		_spec.ClearField(mailbox.FieldMaildir, field.TypeString)
	}
	if value, ok := mu.mutation.UID(); ok {
		_spec.SetField(mailbox.FieldUID, field.TypeInt32, value)
	}
	if value, ok := mu.mutation.AddedUID(); ok {
		_spec.AddField(mailbox.FieldUID, field.TypeInt32, value)
	}
	if mu.mutation.UIDCleared() {
		_spec.ClearField(mailbox.FieldUID, field.TypeInt32)
	}
	if value, ok := mu.mutation.Gid(); ok {
		_spec.SetField(mailbox.FieldGid, field.TypeInt32, value)
	}
	if value, ok := mu.mutation.AddedGid(); ok {
		_spec.AddField(mailbox.FieldGid, field.TypeInt32, value)
	}
	if mu.mutation.GidCleared() {
		_spec.ClearField(mailbox.FieldGid, field.TypeInt32)
	}
	if mu.mutation.DomainCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   mailbox.DomainTable,
			Columns: []string{mailbox.DomainColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(domain.FieldID, field.TypeInt64),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := mu.mutation.DomainIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   mailbox.DomainTable,
			Columns: []string{mailbox.DomainColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(domain.FieldID, field.TypeInt64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, mu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{mailbox.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	mu.mutation.done = true
	return n, nil
}

// MailboxUpdateOne is the builder for updating a single Mailbox entity.
type MailboxUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *MailboxMutation
}

// SetActive sets the "active" field.
func (muo *MailboxUpdateOne) SetActive(b bool) *MailboxUpdateOne {
	muo.mutation.SetActive(b)
	return muo
}

// SetNillableActive sets the "active" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableActive(b *bool) *MailboxUpdateOne {
	if b != nil {
		muo.SetActive(*b)
	}
	return muo
}

// SetModified sets the "modified" field.
func (muo *MailboxUpdateOne) SetModified(t time.Time) *MailboxUpdateOne {
	muo.mutation.SetModified(t)
	return muo
}

// ClearModified clears the value of the "modified" field.
func (muo *MailboxUpdateOne) ClearModified() *MailboxUpdateOne {
	muo.mutation.ClearModified()
	return muo
}

// SetDomainID sets the "domain_id" field.
func (muo *MailboxUpdateOne) SetDomainID(i int64) *MailboxUpdateOne {
	muo.mutation.SetDomainID(i)
	return muo
}

// SetNillableDomainID sets the "domain_id" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableDomainID(i *int64) *MailboxUpdateOne {
	if i != nil {
		muo.SetDomainID(*i)
	}
	return muo
}

// ClearDomainID clears the value of the "domain_id" field.
func (muo *MailboxUpdateOne) ClearDomainID() *MailboxUpdateOne {
	muo.mutation.ClearDomainID()
	return muo
}

// SetUsername sets the "username" field.
func (muo *MailboxUpdateOne) SetUsername(s string) *MailboxUpdateOne {
	muo.mutation.SetUsername(s)
	return muo
}

// SetNillableUsername sets the "username" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableUsername(s *string) *MailboxUpdateOne {
	if s != nil {
		muo.SetUsername(*s)
	}
	return muo
}

// SetPassword sets the "password" field.
func (muo *MailboxUpdateOne) SetPassword(b []byte) *MailboxUpdateOne {
	muo.mutation.SetPassword(b)
	return muo
}

// SetName sets the "name" field.
func (muo *MailboxUpdateOne) SetName(s string) *MailboxUpdateOne {
	muo.mutation.SetName(s)
	return muo
}

// SetNillableName sets the "name" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableName(s *string) *MailboxUpdateOne {
	if s != nil {
		muo.SetName(*s)
	}
	return muo
}

// ClearName clears the value of the "name" field.
func (muo *MailboxUpdateOne) ClearName() *MailboxUpdateOne {
	muo.mutation.ClearName()
	return muo
}

// SetQuota sets the "quota" field.
func (muo *MailboxUpdateOne) SetQuota(i int64) *MailboxUpdateOne {
	muo.mutation.ResetQuota()
	muo.mutation.SetQuota(i)
	return muo
}

// SetNillableQuota sets the "quota" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableQuota(i *int64) *MailboxUpdateOne {
	if i != nil {
		muo.SetQuota(*i)
	}
	return muo
}

// AddQuota adds i to the "quota" field.
func (muo *MailboxUpdateOne) AddQuota(i int64) *MailboxUpdateOne {
	muo.mutation.AddQuota(i)
	return muo
}

// SetLocalPart sets the "local_part" field.
func (muo *MailboxUpdateOne) SetLocalPart(s string) *MailboxUpdateOne {
	muo.mutation.SetLocalPart(s)
	return muo
}

// SetNillableLocalPart sets the "local_part" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableLocalPart(s *string) *MailboxUpdateOne {
	if s != nil {
		muo.SetLocalPart(*s)
	}
	return muo
}

// SetHomedir sets the "homedir" field.
func (muo *MailboxUpdateOne) SetHomedir(s string) *MailboxUpdateOne {
	muo.mutation.SetHomedir(s)
	return muo
}

// SetNillableHomedir sets the "homedir" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableHomedir(s *string) *MailboxUpdateOne {
	if s != nil {
		muo.SetHomedir(*s)
	}
	return muo
}

// ClearHomedir clears the value of the "homedir" field.
func (muo *MailboxUpdateOne) ClearHomedir() *MailboxUpdateOne {
	muo.mutation.ClearHomedir()
	return muo
}

// SetMaildir sets the "maildir" field.
func (muo *MailboxUpdateOne) SetMaildir(s string) *MailboxUpdateOne {
	muo.mutation.SetMaildir(s)
	return muo
}

// SetNillableMaildir sets the "maildir" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableMaildir(s *string) *MailboxUpdateOne {
	if s != nil {
		muo.SetMaildir(*s)
	}
	return muo
}

// ClearMaildir clears the value of the "maildir" field.
func (muo *MailboxUpdateOne) ClearMaildir() *MailboxUpdateOne {
	muo.mutation.ClearMaildir()
	return muo
}

// SetUID sets the "uid" field.
func (muo *MailboxUpdateOne) SetUID(i int32) *MailboxUpdateOne {
	muo.mutation.ResetUID()
	muo.mutation.SetUID(i)
	return muo
}

// SetNillableUID sets the "uid" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableUID(i *int32) *MailboxUpdateOne {
	if i != nil {
		muo.SetUID(*i)
	}
	return muo
}

// AddUID adds i to the "uid" field.
func (muo *MailboxUpdateOne) AddUID(i int32) *MailboxUpdateOne {
	muo.mutation.AddUID(i)
	return muo
}

// ClearUID clears the value of the "uid" field.
func (muo *MailboxUpdateOne) ClearUID() *MailboxUpdateOne {
	muo.mutation.ClearUID()
	return muo
}

// SetGid sets the "gid" field.
func (muo *MailboxUpdateOne) SetGid(i int32) *MailboxUpdateOne {
	muo.mutation.ResetGid()
	muo.mutation.SetGid(i)
	return muo
}

// SetNillableGid sets the "gid" field if the given value is not nil.
func (muo *MailboxUpdateOne) SetNillableGid(i *int32) *MailboxUpdateOne {
	if i != nil {
		muo.SetGid(*i)
	}
	return muo
}

// AddGid adds i to the "gid" field.
func (muo *MailboxUpdateOne) AddGid(i int32) *MailboxUpdateOne {
	muo.mutation.AddGid(i)
	return muo
}

// ClearGid clears the value of the "gid" field.
func (muo *MailboxUpdateOne) ClearGid() *MailboxUpdateOne {
	muo.mutation.ClearGid()
	return muo
}

// SetDomain sets the "domain" edge to the Domain entity.
func (muo *MailboxUpdateOne) SetDomain(d *Domain) *MailboxUpdateOne {
	return muo.SetDomainID(d.ID)
}

// Mutation returns the MailboxMutation object of the builder.
func (muo *MailboxUpdateOne) Mutation() *MailboxMutation {
	return muo.mutation
}

// ClearDomain clears the "domain" edge to the Domain entity.
func (muo *MailboxUpdateOne) ClearDomain() *MailboxUpdateOne {
	muo.mutation.ClearDomain()
	return muo
}

// Where appends a list predicates to the MailboxUpdate builder.
func (muo *MailboxUpdateOne) Where(ps ...predicate.Mailbox) *MailboxUpdateOne {
	muo.mutation.Where(ps...)
	return muo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (muo *MailboxUpdateOne) Select(field string, fields ...string) *MailboxUpdateOne {
	muo.fields = append([]string{field}, fields...)
	return muo
}

// Save executes the query and returns the updated Mailbox entity.
func (muo *MailboxUpdateOne) Save(ctx context.Context) (*Mailbox, error) {
	muo.defaults()
	return withHooks(ctx, muo.sqlSave, muo.mutation, muo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (muo *MailboxUpdateOne) SaveX(ctx context.Context) *Mailbox {
	node, err := muo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (muo *MailboxUpdateOne) Exec(ctx context.Context) error {
	_, err := muo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (muo *MailboxUpdateOne) ExecX(ctx context.Context) {
	if err := muo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (muo *MailboxUpdateOne) defaults() {
	if _, ok := muo.mutation.Modified(); !ok && !muo.mutation.ModifiedCleared() {
		v := mailbox.UpdateDefaultModified()
		muo.mutation.SetModified(v)
	}
}

func (muo *MailboxUpdateOne) sqlSave(ctx context.Context) (_node *Mailbox, err error) {
	_spec := sqlgraph.NewUpdateSpec(mailbox.Table, mailbox.Columns, sqlgraph.NewFieldSpec(mailbox.FieldID, field.TypeInt64))
	id, ok := muo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Mailbox.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := muo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, mailbox.FieldID)
		for _, f := range fields {
			if !mailbox.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != mailbox.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := muo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := muo.mutation.Active(); ok {
		_spec.SetField(mailbox.FieldActive, field.TypeBool, value)
	}
	if value, ok := muo.mutation.Modified(); ok {
		_spec.SetField(mailbox.FieldModified, field.TypeTime, value)
	}
	if muo.mutation.ModifiedCleared() {
		_spec.ClearField(mailbox.FieldModified, field.TypeTime)
	}
	if value, ok := muo.mutation.Username(); ok {
		_spec.SetField(mailbox.FieldUsername, field.TypeString, value)
	}
	if value, ok := muo.mutation.Password(); ok {
		_spec.SetField(mailbox.FieldPassword, field.TypeBytes, value)
	}
	if value, ok := muo.mutation.Name(); ok {
		_spec.SetField(mailbox.FieldName, field.TypeString, value)
	}
	if muo.mutation.NameCleared() {
		_spec.ClearField(mailbox.FieldName, field.TypeString)
	}
	if value, ok := muo.mutation.Quota(); ok {
		_spec.SetField(mailbox.FieldQuota, field.TypeInt64, value)
	}
	if value, ok := muo.mutation.AddedQuota(); ok {
		_spec.AddField(mailbox.FieldQuota, field.TypeInt64, value)
	}
	if value, ok := muo.mutation.LocalPart(); ok {
		_spec.SetField(mailbox.FieldLocalPart, field.TypeString, value)
	}
	if value, ok := muo.mutation.Homedir(); ok {
		_spec.SetField(mailbox.FieldHomedir, field.TypeString, value)
	}
	if muo.mutation.HomedirCleared() {
		_spec.ClearField(mailbox.FieldHomedir, field.TypeString)
	}
	if value, ok := muo.mutation.Maildir(); ok {
		_spec.SetField(mailbox.FieldMaildir, field.TypeString, value)
	}
	if muo.mutation.MaildirCleared() {
		_spec.ClearField(mailbox.FieldMaildir, field.TypeString)
	}
	if value, ok := muo.mutation.UID(); ok {
		_spec.SetField(mailbox.FieldUID, field.TypeInt32, value)
	}
	if value, ok := muo.mutation.AddedUID(); ok {
		_spec.AddField(mailbox.FieldUID, field.TypeInt32, value)
	}
	if muo.mutation.UIDCleared() {
		_spec.ClearField(mailbox.FieldUID, field.TypeInt32)
	}
	if value, ok := muo.mutation.Gid(); ok {
		_spec.SetField(mailbox.FieldGid, field.TypeInt32, value)
	}
	if value, ok := muo.mutation.AddedGid(); ok {
		_spec.AddField(mailbox.FieldGid, field.TypeInt32, value)
	}
	if muo.mutation.GidCleared() {
		_spec.ClearField(mailbox.FieldGid, field.TypeInt32)
	}
	if muo.mutation.DomainCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   mailbox.DomainTable,
			Columns: []string{mailbox.DomainColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(domain.FieldID, field.TypeInt64),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := muo.mutation.DomainIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   mailbox.DomainTable,
			Columns: []string{mailbox.DomainColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(domain.FieldID, field.TypeInt64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Mailbox{config: muo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, muo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{mailbox.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	muo.mutation.done = true
	return _node, nil
}
